using Sandbox;
using Sandbox.UI;
public class Bird: Panel{

	bool _stop = true;
	public bool stop{
		get { return _stop; }
		set
		{
			if ( value == true )
			{
				this.SetProperty( "style", $"bottom: {50}%;" );
				_stop = true;
				momentum = 0;
				this.RemoveClass( "let" );
				height = 50;
			}
			if ( value == false )
			{
				_stop = false;
			}
		}
	}
	private double momentum = 0; //no need for vector because its only up or down
	public double height { get; private set; } = 50;

	public void fly(){
		momentum = 40;
		this.AddClass( "let" );
        var player = Local.Pawn;
		if ( player == null ) return;
		player.PlaySound( SoundClass.Wings.Name );
	}
	public const double gravity = 80;

	public Bird(){
		this.AddClass( "bird" );
        this.SetProperty( "style", $"bottom: {height}%;" );
	}

	public override void Tick()
	{
		base.Tick();

        if(_stop) return;
		momentum -= gravity * Sandbox.RealTime.Delta;
		height += momentum * Sandbox.RealTime.Delta;
		if(momentum <= 0) this.RemoveClass( "let" );
		this.SetProperty( "style", $"bottom: {height}%;" );

	}
}


    public class SoundClass{
	static public SoundEvent Wings = new( "sounds/wingflap.vsnd");
}	
