using Sandbox;
using Sandbox.UI;



public partial class HUD : HudEntity<RootPanel>
{
	public HUD()
	{
		if ( IsClient ){

			RootPanel.StyleSheet.Load( "/template.scss" );
			RootPanel.AddChild<Template>();

		}

	}

}


partial class MyPlayer : Player
{
	public override void Respawn()
	{
		SetModel( "models/citizen/citizen.vmdl" );
		Controller = new WalkController();
		Animator = new StandardPlayerAnimator();
		Camera = new ThirdPersonCamera();

		
		base.Respawn();
	}
}


public partial class MyGame : Sandbox.Game
{

	public MyGame(){
			if ( IsServer )
			{
			new HUD();

		}
		}

		
	public override void ClientJoined( Client client )
	{
		base.ClientJoined( client );
		var player = new MyPlayer();
		client.Pawn = player;
		player.Respawn();
		
	}
}