using Sandbox;
using Sandbox.UI;

public  class Pipe : Panel
{
	public double[] height = new double[2];
	public double position = -40;

	public Pipe(double gap){
		StyleSheet.Load( "template.scss" );
		this.AddClass( "pipe" );
		string color = PipePart.RandColor();

		var rand = new System.Random();
		height[0] = rand.Next( 15, 80 );
		height[1] = 100 - gap - height[0];
		PipePart p1 = new PipePart(height[0], color);
		this.AddChild(p1);
		if ( height[1] > 2 )
		{
			PipePart p2 = new PipePart( height[1], color );
			p2.SetProperty( "style", "transform: rotateX(180); top:0px" );
			this.AddChild( p2 );
		}

	}

	const double speed = 21;
	public override void Tick()
	{
		base.Tick();
		position += speed * RealTime.Delta;
		this.SetProperty( "style", $"right: {position}%" );

	}
}


public partial class PipePart : Panel
{

    public PipePart(double visina, string color){
		this.AddClass( "kontener" );

		Panel p1 = new Panel( this, "pipe1" );
		Panel p2 = new Panel( this, "pipe2" );
		p1.SetProperty( "style", "background-color: " + color + ";" );
		p2.SetProperty( "style", "background-color: " + color + ";" );
        

		StyleSheet.Parse( ".kontener{width: 100%; bottom: 0px; height: " + $"{visina}" + "%; position: absolute;}" );

	}

    public static string RandColor(){
        var rand = new System.Random();
		string color = "#";
        for ( int i = 0; i < 6;  ++i)
            if(rand.Next( 0, 9 ) >= 5)
                color += (char)(rand.Next('A', 'F'));
            else
                color += rand.Next(0, 9);
		return color;
	}

}