using Sandbox;
using Sandbox.UI;
using System.Collections.Generic;

[UseTemplate]
public class Template: Panel{

	public Bird bird{ get; set; }

	private Panel LostMeni{ get; set; }
	private bool _GameStatus = false;
	public bool GameStatus
	{
		get { return _GameStatus; }
		set { 
			if (value){			
				label.AddClass( "hide" );
				LostMeni.AddClass( "hide" );
				score = 0;
				bird.stop = false;
				_GameStatus = true;
				return;
			} 
			if(!value){
				label.RemoveClass( "hide" );
				LostMeni.RemoveClass( "hide" );
				bird.stop = true;
				_GameStatus = false;
				foreach ( var a in pipes ) a.Delete();
				pipes.Clear();
				var player = Local.Pawn;
				if ( player == null ) return;
					if(score < 10)
						player.PlaySound( SoundClass2.Laugh.Name );
					else
						player.PlaySound( SoundClass3.Clap.Name );

			}
		}
	}

	public Panel game{ get; set; }

	float Time;

	public int score{ get; set; } = 0;

	LinkedList<Pipe> pipes = new LinkedList<Pipe>();

	public void action(Panel p){
		if(GameStatus)
			bird.fly();
		else
			GameStatus = true;
	}
	public Label label{ get; set; }
	System.Random rand = new System.Random();
	private void SpawnPipe(){
		pipes.AddLast( new Pipe( rand.Next( 15, 17 ) ) );
		game.AddChild(pipes.Last.Value);
	}

	public Template(){
		Time = RealTime.Now;
	}

	bool remove = false;
	public override void Tick(){
		base.Tick();
		if ( GameStatus )
		{
			if ( RealTime.Now > Time )
			{
				Time = RealTime.Now + rand.Next( 3, 8 );
				SpawnPipe();
			}

			if(remove){
				pipes.RemoveFirst();
				remove = false;
			}
			foreach(var a in pipes){
				if ( a.position > 73 )
				{
					if(a.position > 88){
						++score;
						remove = true;
						continue;
					}
					else
						if (a.height[0] > (bird.height - 1) || (100 - a.height[1]) < (bird.height + 2))
					{
						GameStatus = false;
						break;
					}
				}
			}
			if(bird.height < 3 || bird.height > 99)
				GameStatus = false;
		}
	}


}

    public class SoundClass2{
	static public SoundEvent Laugh = new( "sounds/laugh.vsnd");
}	
    public class SoundClass3{
	static public SoundEvent Clap = new( "sounds/clap.vsnd");
}	
